//------------------------------------------------------------------
#property copyright "mladen"
#property link      "mladenfx@gmail.com"
//------------------------------------------------------------------
#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1  C'225,0,0'
#property indicator_color2  C'0,225,0'
#property indicator_width1  2
#property indicator_width2  2

//
//
//
//
//

extern string TimeFrame  = "Current time frame";
extern int    RsiLength1 =  5;
extern int    RsiLength2 =  8;
extern int    RsiLength3 = 11;
extern int    RsiLength4 = 14;
extern int    RsiLength5 = 17;
extern int    RsiLength6 = 20;
extern int    RsiLength7 = 24;
extern int    RsiLength8 =  0;
extern int    RsiPrice   = PRICE_CLOSE;
extern int    Group      = 6;
extern double LevelUp    = 70;
extern double LevelDown  = 30;
extern double GapUp      = 0.25;
extern double GapDown    = 0.25;

double signalUp[];
double signalDn[];

int      timeFrame;
bool     returnBars;
string   indicatorFileName;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,signalUp); SetIndexStyle(0,DRAW_ARROW); SetIndexArrow(0,159);
   SetIndexBuffer(1,signalDn); SetIndexStyle(1,DRAW_ARROW); SetIndexArrow(1,159);
         indicatorFileName = WindowExpertName();
         returnBars        = (TimeFrame=="returnBars"); if (returnBars) return(0);
         timeFrame         = stringToTimeFrame(TimeFrame);
   IndicatorShortName(timeFrameToString(timeFrame)+" RSI fan signals");
   return(0);
}
int deinit(){ return(0); }


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars = IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars > 0) counted_bars--;
           int limit = MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { signalUp[0] = limit+1; return(0); }
           if (timeFrame != Period()) limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));

   for(int i = limit; i>=0; i--)
 	{
      int    y      = iBarShift(NULL,timeFrame,Time[i]);
      int    x      = iBarShift(NULL,timeFrame,Time[i+1]);
       signalUp[i] = EMPTY_VALUE;
       signalDn[i] = EMPTY_VALUE;
       if (x!=y)
       {
         int    result = 0;
         double rsi;
    	    if (RsiLength1>1)  { rsi = iRSI(NULL,timeFrame,RsiLength1,RsiPrice,y); result += (rsi > LevelUp); result -= (rsi < LevelDown); }
 	       if (RsiLength2>1)  { rsi = iRSI(NULL,timeFrame,RsiLength2,RsiPrice,y); result += (rsi > LevelUp); result -= (rsi < LevelDown); }
 	       if (RsiLength3>1)  { rsi = iRSI(NULL,timeFrame,RsiLength3,RsiPrice,y); result += (rsi > LevelUp); result -= (rsi < LevelDown); }
 	       if (RsiLength4>1)  { rsi = iRSI(NULL,timeFrame,RsiLength4,RsiPrice,y); result += (rsi > LevelUp); result -= (rsi < LevelDown); }
 	       if (RsiLength5>1)  { rsi = iRSI(NULL,timeFrame,RsiLength5,RsiPrice,y); result += (rsi > LevelUp); result -= (rsi < LevelDown); }
 	       if (RsiLength6>1)  { rsi = iRSI(NULL,timeFrame,RsiLength6,RsiPrice,y); result += (rsi > LevelUp); result -= (rsi < LevelDown); }
 	       if (RsiLength7>1)  { rsi = iRSI(NULL,timeFrame,RsiLength7,RsiPrice,y); result += (rsi > LevelUp); result -= (rsi < LevelDown); }
 	       if (RsiLength8>1)  { rsi = iRSI(NULL,timeFrame,RsiLength8,RsiPrice,y); result += (rsi > LevelUp); result -= (rsi < LevelDown); }
 	       if (result>= Group) signalUp[i] = High[i]+iATR(NULL,0,10,i)*GapUp;
 	       if (result<=-Group) signalDn[i] = Low[i] -iATR(NULL,0,10,i)*GapDown;
      } 	       
   } 	    
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

int stringToTimeFrame(string tfs)
{
   StringToUpper(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}